> For the complete documentation index, see [llms.txt](https://docs.hackle.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.hackle.io/en/development-guide/flutter/flutter-optout.md).

# Opt-out

When Opt-out is enabled, the SDK stops sending all events.

{% hint style="info" %}
Flutter SDK is built on top of Android SDK and iOS SDK.
{% endhint %}

## Configure at Initialization

```dart
import "package:hackle/hackle.dart";

HackleConfig config = HackleConfigBuilder()
    .optOutTracking(true)
    .build();

await HackleApp.initialize(YOUR_APP_SDK_KEY, hackleConfig: config);
```

## Runtime Opt-out Control

```dart
await HackleApp.setOptOutTracking(true);
await HackleApp.setOptOutTracking(false);
bool isOptOut = await HackleApp.isOptOutTracking();
```

## Persistence Management

{% hint style="warning" %}
The Opt-out state changed at runtime is reset to the value set in the initialization Config when the app restarts.

To persist the state across app restarts, you must implement your own save and restore logic.
{% endhint %}

```dart
import 'package:shared_preferences/shared_preferences.dart';
import 'package:hackle/hackle.dart';

Future<void> saveOptOutState(bool optOut) async {
    final prefs = await SharedPreferences.getInstance();
    await prefs.setBool('hackle_opt_out', optOut);
    await HackleApp.setOptOutTracking(optOut);
}

Future<HackleConfig> getOptOutConfig() async {
    final prefs = await SharedPreferences.getInstance();
    final optOut = prefs.getBool('hackle_opt_out') ?? false;
    return HackleConfigBuilder()
        .optOutTracking(optOut)
        .build();
}

final config = await getOptOutConfig();
await HackleApp.initialize(YOUR_APP_SDK_KEY, hackleConfig: config);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.hackle.io/en/development-guide/flutter/flutter-optout.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
